#!/bin/bash
# Copyright 2018 Michal Žejdl
# snmpgetnext hrProcessorLoad and store to RRD

confdir=$(dirname $0)/../..
config=$confdir/defaults.sh
test -f $config || exit
. $config

functions=$coredir/snmp/functions.sh
test -f $functions || exit
. $functions

address=$1
agent=$2

# group write permissions for rrdcached
umask 002

rrddestdir=$rrddir/snmpagent/$agent/hostResources
test -d "$rrddestdir" || mkdir -p "$rrddestdir" || exit

# see agents.sh
snmpgetnexttimeout=3
hrProcessorLoad_OID=.1.3.6.1.2.1.25.3.3.1.2

result=$(snmpgetnext -m '' -v 1 -r 0 -t $snmpgetnexttimeout -c $snmprcommunity -Onq $address $hrProcessorLoad_OID)

snmpget_status=$?

# be verbose about snmpgetnext error
#if test $snmpget_status -ne 0
#then
#	echo "$(date "+%F %T") $(basename $0): agent $agent with address $address has some hostResources, but returned no hrProcessorLoad"
#	exit $snmpget_status
#fi

test $snmpget_status -eq 0 || exit $snmpget_status

result_OID=${result%% *}
# strip index
result_base=${result_OID%.*}

hrProcessorLoad=U
if test "$result_base" = "$hrProcessorLoad_OID"
then
	# strip OID
	value=${result#* }

#	if is_natural_number "$value"
#	then
#		hrProcessorLoad=$value
#	else
#		echo "$(date "+%F %T") $(basename $0): agent $agent with address $address returned unexpected value $value for hrProcessorLoad"
#	fi

	is_natural_number "$value" && hrProcessorLoad=$value

#else
#	echo "$(date "+%F %T") $(basename $0): agent $agent with address $address has some hostResources, but returned no hrProcessorLoad"

fi

if test "$hrProcessorLoad" != U
then
	rrdfile="$rrddestdir/hrProcessorLoad.rrd"
	test -f "$rrdfile" || create_rrd_gauge "$rrdfile" "$snmpinterval" 0
	rrdtool update "$rrdfile" $rrdcached N:$hrProcessorLoad
fi
