#!/bin/bash
# Copyright 2014, 2015 Michal Žejdl

confdir=$(dirname $0)/../core
config=$confdir/defaults.sh
test -f $config || exit
. $config || exit

echo "creating system user $user"
# -m is for /home dir and it is for "su -" - see init.sh
useradd -m -r $user
# rights to the socket
usermod -a -G rrdcached $user
# rights to the RRD files
usermod -a -G $user rrdcached

# $config is changed to conf.sh - see the end of defaults.sh
chown -Rv $user: $config $logdir $rundir

test -d $rrdifdir || mkdir -pv $rrdifdir
test -d "$rrddir/snmpagent" || mkdir -pv "$rrddir/snmpagent"
test -d $rrdstatsdir || mkdir -pv $rrdstatsdir
chown -v $user: $rrdifdir "$rrddir/snmpagent" $rrdstatsdir
