#include "list.h"

#include "log.h"

// malloc()
#include <stdlib.h>

void list_init(struct list *list)
{
	list->count = 0;
	list->head = list->tail = NULL;
}

int list_append(struct list *list, void *data)
{
	struct list_element *new_el;
	// no point to store empty data
	if (data == NULL)
		return 0;
	new_el = malloc(sizeof(struct list_element));
	if (new_el == NULL)
		return 0;
	new_el->data = data;
	new_el->next = NULL;
	list->count++;
	// append to empty list
	if (list->head == NULL)
		list->head = new_el;
	if (list->tail != NULL)
		list->tail->next = new_el;
	list->tail = new_el;
	return 1;
}

/*int list_insert(struct list *list, void *data)
{
	struct list_element *new_el;
	new_el = malloc(sizeof(struct list_element));
	if (new_el == NULL) return 0;
	new_el->data = data;
	new_el->next = list->head;
	list->count++;
	list->head = new_el;
	return 1;
}*/

void *list_get_head(struct list *list)
{
	if (list->head == NULL) return NULL;
	return list->head->data;
}

void *list_cut_head(struct list *list)
{
	struct list_element *old_el;
	void *data;
	if (list->head == NULL) return NULL;
	old_el = list->head;
	list->count--;
	list->head = list->head->next;
	// check count for 0 or head for NULL?
	if (list->count == 0) list->tail = NULL;
	data = old_el->data;
	free(old_el);
	return data;
}

/*void list_free(struct list *list)
{
	void *data;
	while ((data = list_cut_head(list)) != NULL) free(data);
}*/

void list_delete_head(struct list *list)
{
	free(list_cut_head(list));
}

void list_delete_all(struct list *list)
{
	while (list->head != NULL)
		list_delete_head(list);
}

void list_shrink(struct list *list, int maximum, int desired)
{
	int over;
	if (list->count < maximum)
		return;
	log_print_time();
	fprintf(logfile, "can not flush queue to database, shrinking list size from %d to %d\n", list->count, desired);
	for (over = list->count; over > desired; over--)
		list_delete_head(list);
}
