#!/bin/bash
# Copyright 2018 Michal Žejdl
# more generic graph creation
# correct integers to the right values (/10)

# check number of arguments
test $# -lt 7 && exit

rrdbasedir=$1
rrdfile=$2
outputdir=$3
starttime=$4
endtime=$5
title=$6
vlabel=$7

# make the remote flush possible
cd $rrdbasedir || exit

test -d "$outputdir" || mkdir -p "$outputdir" || exit

# lazy (-z) is handy
options="-s $starttime -e $endtime -z"

# append rrdcached
test $# -gt 7 && options="$options --daemon $8"

filename=$(basename $rrdfile .rrd)

rrdtool graph \
$outputdir/$filename-$starttime-$endtime.png \
$options -t "$title" -v "$vlabel" \
DEF:aa=$rrdfile:a:AVERAGE \
DEF:an=$rrdfile:a:MIN \
DEF:am=$rrdfile:a:MAX \
DEF:al=$rrdfile:a:LAST \
CDEF:aad=aa,10,/ \
CDEF:and=an,10,/ \
CDEF:amd=am,10,/ \
CDEF:ald=al,10,/ \
VDEF:aaa=aad,AVERAGE \
VDEF:ann=and,MINIMUM \
VDEF:amm=amd,MAXIMUM \
VDEF:all=ald,LAST \
TEXTALIGN:left \
LINE2:aad#0000cc:"  " \
GPRINT:aaa:"avg\: %6.2lf %s" \
GPRINT:ann:"min\: %6.2lf %s" \
GPRINT:amm:"max\: %6.2lf %s" \
GPRINT:all:"lst\: %6.2lf %s\l"
