<?php

/*
 * Copyright 2015 - 2018 Michal Žejdl
 */

$document_root = "..";

require "$document_root/init.php";

$title = gettext("SNMP agent");

page_open($document_root, $title);



if (!isset($_GET["id"]))
	exit("<p>" . gettext("the id argument is missing"));

$snmpagentid = $_GET["id"];
  
// a validation check
if (!preg_match("/^[[:digit:]]+$/", $snmpagentid))
	exit("<p>\"$snmpagentid\" " . gettext("doesn't look as a natural number") . "\n");


//echo "<h1>$title</h1>\n";


// creating $query_limit
if (isset($_GET["nolimit"])) $query_limit = "";
else $query_limit = " limit ".$limit;


$connection = mysql_connect($dbhost, $dbuser, $dbpass);

if (!$connection)
	exit(gettext("database connection error"));

mysql_select_db($dbname);


print_snmp_header($document_root, $snmpagentid);



echo "<h2>system MIB</h2>\n";



$result = mysql_query("select
		from_unixtime(time) time, sysDescr, sysObjectID, sysUpTime,
		from_unixtime(time - sysUpTime / 100) start, sysContact,
		sysName, sysLocation, sysServices, dot1dTpFdbEntry, ifXEntry 
		from snmpagent where id = $snmpagentid");

//$debug = true;

if ($row = mysql_fetch_assoc($result)) {
	debug_print($row["sysName"]);
	$system = array("time", "sysDescr", "sysObjectID",
			"sysUpTime", "start", "sysContact", "sysName",
			"sysLocation", "sysServices");
	echo "<table summary=\"", gettext("SNMP MIB-2 System table"), "\">\n";
	echo "<tbody>\n";
	foreach ($system as $item) {
		$anchor = "";
		$anchor_end = "";
		if ($item == "sysObjectID") {
			if ($organization = sysObjectID2organization(
						$row["sysObjectID"]))
				if ($organization == "APC") {
					$anchor = "<a href=\"mib/APC.php?agent=" . $snmpagentid . "\">";
					$anchor_end = "</a>";
				}
		}
		echo "<tr class=\"monospace zebra\">",
		     "<th>$item",
		     "<td>$anchor$row[$item]$anchor_end",
		     "\n";

		if ($item == "sysLocation")
			print_external_links_for_location($row[$item]);
	}
	echo "</tbody>\n";
	echo "</table>\n";
	echo "<p>(*) ", gettext("The entry <b>start</b> is estimate time when system was started or 32b sysUpTime overflowed (once every 497 days). Some agents have sysUpTime slowed by seconds in minutes so the entry <b>start</b> can be far from reality.");
	echo "\n";

	// save values for use at the end of this script
	$dot1dTpFdbEntry = $row["dot1dTpFdbEntry"];
	$ifXEntry = $row["ifXEntry"];

} else {
	echo "<p>";
	printf(gettext("SNMP agent no %s was not found in the database."), $snmpagentid);
	echo "\n";
}

// IPv4 addresses

$result = mysql_query("select address, get time from snmp4
		where status = 0 and agent = $snmpagentid order by time desc");
if (mysql_num_rows($result) > 0) {
	$table_name = gettext("IPv4 adresses of agent");
	echo "<h2>$table_name</h2>\n";
	echo "<table summary=\"$table_name\">\n";
	echo "<tr>", "<th>", gettext("address"), "<th>SNMP get", "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_assoc($result)) {
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">",
		     "<td><a href=\"../ipv4.php?id=", $row["address"],
		     "\">",
		     $row["address"], "</a>",
		     "<td class=\"center\">", date_formated($row["time"]),
		     "\n";
	}
	echo "</table>\n";
}

// IPv6 addresses

$result = mysql_query("select address, get time from snmp6
		where status = 0 and agent = $snmpagentid order by time desc");
if (mysql_num_rows($result) > 0) {
	$table_name = gettext("IPv6 adresses of agent");
	echo "<h2>$table_name</h2>\n";
	echo "<table summary=\"$table_name\">\n";
	echo "<tr>", "<th>", gettext("address"), "<th>SNMP get", "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_assoc($result)) {
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">";

		echo "<td>";
		print_url("../ipv6.php?id=" . $row["address"],
				ipv6_compress($row["address"]));

		echo "<td class=\"center\">", date_formated($row["time"]),
		     "\n";
	}
	echo "</table>\n";
}

/*
echo "<h2><a href=\"mib/ifgraph.php?agent=$snmpagentid\">",
     "interfaces graphs</a></h2>\n";

echo "<h2><a href=\"mib/iftable.php?agent=$snmpagentid\">",
     "MIB ifTable</a></h2>\n";

if ($dot1dTpFdbEntry == "y")
echo "<h2><a href=\"mib/fdb.php?agent=$snmpagentid\">",
     "MIB FdbTable</a>";

if ($ifXEntry == "y")
echo "<h2><a href=\"mib/ifxtable.php?agent=$snmpagentid\">",
     "MIB ifXTable</a></h2>\n";

if ($organization)
	echo "<h2><a href=\"mib/$organization.php?agent=$snmpagentid\">",
	"MIB $organization</a></h2>\n";
*/


page_close($document_root);

?>
